# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Segmap do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :mediaId,
    :mask,
    :area,
    :boundingBox,
    :hash,
    :classId,
    :isCrowd,
    :segmentation,
    :confidence,
    :source,
    :attributes,
    :updatedAt,
    :createdAt,
    :Media
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :mediaId => integer() | nil,
    :mask => String.t | nil,
    :area => integer() | nil,
    :boundingBox => [integer()] | nil,
    :hash => String.t | nil,
    :classId => integer() | nil,
    :isCrowd => integer() | nil,
    :segmentation => String.t | nil,
    :confidence => float() | nil,
    :source => String.t | nil,
    :attributes => [FoyerAPI.Model.Attribute.t] | nil,
    :updatedAt => Date.t | nil,
    :createdAt => Date.t | nil,
    :Media => FoyerAPI.Model.Media.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Segmap do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:attributes, :list, FoyerAPI.Model.Attribute, options)
    |> deserialize(:updatedAt, :date, nil, options)
    |> deserialize(:createdAt, :date, nil, options)
    |> deserialize(:Media, :struct, FoyerAPI.Model.Media, options)
  end
end

